/*
 *  Copyright (c) 2004 on behalf of the EU EGEE Project:
 *  The European Organization for Nuclear Research (CERN),
 *  Istituto Nazionale di Fisica Nucleare (INFN), Italy
 *  Datamat Spa, Italy
 *  Centre National de la Recherche Scientifique (CNRS), France
 *  CS Systeme d'Information (CSSI), France
 *  Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
 *  Universiteit van Amsterdam (UvA), Netherlands
 *  University of Helsinki (UH.HIP), Finland
 *  University of Bergen (UiB), Norway
 *  Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom
 */
#ifndef ERROR_MESSAGES_HH
#define ERROR_MESSAGES_HH

#include <string>

namespace glite
{
    namespace rgma
    {
        /**
         * RGMA error messages
         * 
         */
        class ErrorMessages
        {
            public:
                // XXX: those not used now are commented out...
                // XXX: We should split the messages up I reckon into common,
                // regsitryservlet, registry etc maybe by type of error or
                // function?  Something so I can find out if the message I want is
                // already in here!!!  Oh and we need more than 100 of them!  mm
                // message catalogue should surely contain all language dependent
                // text? Why then do several errors that get produced start
                // including tableName flags etc!!!
                static const std::string API;
                // The XMLConverter looks for 'Servlet' and not 'servlet
                // This occurs when an InstanceBase throws an RGMAException - RB
                static const std::string SERVLET;
                static const std::string MSG1;
                static const std::string MSG2;    //schema servlet, ArchiverInstance
                static const std::string MSG3;    //schema servlet
                static const std::string MSG4;    // schema servlet
                static const std::string MSG5;    // schema servlet
                static const std::string MSG6;    // ServletConnection
                static const std::string MSG7;    // ServletConnection
                static const std::string MSG8;    // XMLConverter
                static const std::string MSG9;    //CircularBufferProducer
                static const std::string MSG10;   // Registry (flags can't be < 1)
                static const std::string MSG11;   // PropertyGetter
                static const std::string MSG12;   // Consumer
                static const std::string MSG13;   // ConsumerInstance
                static const std::string MSG14;   // RegistryServlet
                static const std::string MSG15;   // RegistryServlet
                static const std::string MSG16;   // QueryHandler
                static const std::string MSG17;   // InsertableInstance, ProducerInstance, QueryHandler
                static const std::string MSG18;   // RegistryServlet
                static const std::string MSG19;   // InsertableInstance
                static const std::string MSG20;   //RegistryServlet
                static const std::string MSG21;   // StreamProducerInstance
                static const std::string MSG22;   // ConsumerServlet
                static const std::string MSG23;   // ConsumerServlet
                static const std::string MSG24;   // LatestProducerInstance
                static const std::string MSG25;   // LatestProducerInstance
                static const std::string MSG26;   // ServletBase
                static const std::string MSG27;   // ArchiverServlet
                static const std::string MSG28;   // RegistryServlet, BrowserServlet
                static const std::string MSG29;   // ProducerInstance
                static const std::string MSG30;   // InsertableInstance, Insertable
                static const std::string MSG31;
                static const std::string MSG32;   // DeclarableInstance
                static const std::string MSG33;   // DeclarableInstance, CleanableInstance
                static const std::string MSG34;   // DBProducerServlet
                static const std::string MSG35;   // DBProducerInstance, RegistryServlet
                static const std::string MSG36;   // DBProducerServlet, RegistryServlet, SchemaServlet
                static const std::string MSG37;   // ConsumerServlet, ArchiverInstance, StreamProducerInstance
                static const std::string MSG38;   // RegistryServlet
                static const std::string MSG39;   // RegistryServlet
                static const std::string MSG40;   //ConsumerInstance
                static const std::string MSG41;   // CleanableInstance - used when validating a table
                static const std::string MSG42;
                static const std::string MSG43;   // used when inserting a tuple...
                static const std::string MSG44;
                static const std::string MSG46;
                static const std::string MSG47;
                static const std::string MSG48;
                static const std::string MSG49;
                static const std::string MSG50;
                static const std::string MSG51;
                static const std::string MSG52;
                static const std::string MSG53;
                /** Exception message used if the Consumer issues a start() before the
                    previous start() was completed */
                static const std::string MSG54;
                /** Exception message used if the ConsumerServlet cannont identify the
                    Consumer Query Type */
                static const std::string MSG55;
                /** Exception message used if the old Consumer API used pop() but no
                    elements are available */
                static const std::string MSG56;
                /** Exception message used if the StreamingProducer cannot find the
                    Consumer on a stopStreaming() request */
                static const std::string MSG57;
                /** Exception message used if the Consumer resends a start() request */
                static const std::string MSG58;
                /** Exception message used if the Consumer sends an invalid abort() request */
                static const std::string MSG59;
                /** Exception message used if an error occurs when executing an SQL statement
                    in the RegistyServlet */
                static const std::string MSG60;
                /** Exception message used if the ServletConnection is configured to used
                    POST but no body has been defined (either its empty or null) */
                static const std::string MSG61;
                /** Exception message used if no checksum is found when a replication request
                    occurs */
                static const std::string MSG62;
                /** Exception message used if the buffer size is invalid */
                static const std::string MSG63;
                static const std::string MSG64;   // used in InsertableInstance and Time
                static const std::string MSG65;
                /** Exception message used if the count size is < 0. */
                static const std::string MSG66;
                /** Exception message used if the start timeout is < 0 */
                static const std::string MSG67;
                /** Exception message used if an environ var cannot be retrieved. */
                static const std::string MSG68;
                /** Exception message used if the property is not found in the props file. */
                static const std::string MSG69;
                /** Exception raised if the property file cannot be parsed correctly. */
                static const std::string MSG70;
                /** Exception raised by the replication routine if the db connection is faulty. */
                static const std::string MSG71;
                /** Used if an error occurs while querying the registry database. */
                static const std::string MSG72;
                /** Used by Registry when trying to find the fastest RegistryServlet connection */
                static const std::string MSG91;
                static const std::string MSG92;
                static const std::string MSG93;
                static const std::string MSG94;
                static const std::string MSG95;
                /*MSG97; */
                static const std::string MSG98;
                static const std::string MSG99;
                static const std::string MSG100;
                static const std::string MSG101;
                static const std::string MSG102;
                static const std::string MSG103;
                static const std::string MSG104;
                static const std::string MSG105;
                /** exception thrown when pop before start, for new Consumer api + continuous queries */
                static const std::string MSG106;
                /** thrown by CleanableInstance, when a Cleanable constructed with a database has an invalid table in the db*/
                static const std::string MSG107;
                /** If a GRRP heartbeat arrives at the registry too late, then this exception is thrown */
                static const std::string MSG108;
                /** thrown if the Producer buffer is full, or if there's not enough memory available to process the request.*/
                static const std::string MSG109;
                /** thrown if the IO connection between the Producer and Consumer is closed unexpectedly */
                static const std::string MSG110;
                /** thrown if the input message streamed from Producer to Consumer unknown */
                static const std::string MSG111;
                /** If an index value is out of range **/
                static const std::string MSG112;
                static const std::string MSG113;
                /** If no Archivers are available to answer your Latest or History query */
                static const std::string MSG114;
                /** Thrown by the StreamProducer if the Consumer has already started streaming */
                static const std::string MSG115;
                static const std::string MSG116;
                static const std::string MSG117;
                static const std::string MSG118;
                static const std::string MSG119;
                static const std::string MSG120;
                /** thrown if the QueryHandler cannot parse the sql statement of a Consumer */
                static const std::string MSG121;
                /** thrown by the Schema when comparing the date/time stamps */
                static const std::string MSG122;
                /** thrown if Producer table does not match description in Schema */
                static const std::string MSG123;
                /** thrown by the Schema if the columns have been defined NOT NULL */
                static const std::string MSG124;
                /** thrown by the Schema if no columns in a table are defined with a PRIMARY KEY */
                static const std::string MSG125;
                /** thrown by the Schema if an error occurs while parsing the SQL Create statement */
                static const std::string MSG126;
                /** thrown by InsertableInstance if tuple contains invalid Date/Time stamp combo. */
                static const std::string MSG127;
                /** thrown if a record is duplicated in the Registry DB. */
                static const std::string MSG128;
                static const std::string MSG129;
                static const std::string MSG130;
                /** thrown if the number of column names defined within an insert do not match the number of values defined. */
                static const std::string MSG131;
                static const std::string MSG132;
                static const std::string MSG133;
                /** thrown if a parameter read in from web.xml cannot be parsed as a double. */
                static const std::string MSG134;
                /** thrown if the Producer is currently being blocking from host-deny.xml file. */
                static const std::string MSG135;
                /** thrown if the Producer id cannot be located in the Registry. */
                static const std::string MSG136;
                /** thrown by replication routine if unable to read-in xml message. */
                static const std::string MSG137;
                /** thrown by replication routine if replica omits the senders URL. */
                static const std::string MSG138;
                /** thrown by replication routine if a parse error occurs while reading the replica. */
                static const std::string MSG139;
                /** thrown if a Registry receives a replica update and the Registry is synchronizing. */
                static const std::string MSG140;
                /** thrown by replication routine if replica xml message is empty. */
                static const std::string MSG141;
                /** thrown by replication routine if no tables valid tables exist in the db. */
                static const std::string MSG142;
                /** thrown by replication routine if an origin is invalid. */
                static const std::string MSG143;
                /*** throws if replication routine cannot find an origin. */
                static const std::string MSG144;
                /** thrown if the hostname is currently being denied access to any R-GMA servlet. */
                static const std::string MSG145;
                /** replication is not implemented so if several registry urls are defined, this exception is thrown. */
                static const std::string MSG146;
                /** thrown if producer couldn't be found in the registry. */
                static const std::string MSG147;
                static const std::string MSG148;
                /** thrown if the termination interval is too large (when using setTerminationInterval()). */
                static const std::string MSG149;
                static const std::string MSG150;
                static const std::string MSG151;
                static const std::string MSG152;
                static const std::string MSG153;
                /** thrown if the inserted tuple does not honour the registered view. */
                static const std::string MSG154;
                /** thrown if the log4j facility hasn't been initialised. */
                static const std::string MSG155;
                /** raised if a producer is used when answering a one-time query - the producer might be incomplete */
                static const std::string WARNING1;
        };
    }
}
#endif
