/*
 *  Copyright (c) 2004 on behalf of the EU EGEE Project:
 *  The European Organization for Nuclear Research (CERN),
 *  Istituto Nazionale di Fisica Nucleare (INFN), Italy
 *  Datamat Spa, Italy
 *  Centre National de la Recherche Scientifique (CNRS), France
 *  CS Systeme d'Information (CSSI), France
 *  Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
 *  Universiteit van Amsterdam (UvA), Netherlands
 *  University of Helsinki (UH.HIP), Finland
 *  University of Bergen (UiB), Norway
 *  Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom
 */
#ifndef INDEXLIST_H
#define INDEXLIST_H

#include "rgma/Index.h"
#include <vector>
#include <string>

namespace glite
{
    namespace rgma
    {
        /**
         * A list of Index objects.
         */
        class IndexList
        {
            public:
                IndexList();
                ~IndexList(){}

                /**
                 * Retrieves the Index with the specified index.
                 *
                 * @param index Index of Index to get (0 &lt;= index &lt; size)
                 *
                 * @return A Index object.
                 */
                Index getIndex(int index);
                /**
                 * adds an Index to the list
                 *
                 * @param index Index of Index to put
                 *
                 *
                 */
                void add(Index index);
                int size();
            private:
                std::vector<Index> m_indexList;

        };
        std::ostream& operator<<( std::ostream& stream, IndexList indexList);
    }
}
#endif
