#ifndef PRODUCERTABLEENTRYLIST_H
#define PRODUCERTABLEENTRYLIST_H
#include "rgma/ProducerTableEntry.h"
#include <vector>

namespace glite
{
    namespace rgma
    {
        /**
         * Contains list of producer's type and connection details.
         */
        class ProducerTableEntryList
        {
            public:
                /**
                 * Creates a new ProducerDescriptionList object.
                 */
                ProducerTableEntryList();
                virtual ~ProducerTableEntryList();
                /**
                 * Retrieves the ProducerTableEntry with the specified index.
                 *
                 * @param index Index of ProducerTableEntry to get (0 &lt;= index &lt;
                 *        size)
                 * @return A ProducerTableEntry object.
                 */
                ProducerTableEntry getProducerTableEntry(int index);
                /**
                 * adds a ProducerTableEntry to the list.
                 *
                 * @param entry a producer table entry
                 */
                void add(ProducerTableEntry entry);
                int size();
            private:
                std::vector<ProducerTableEntry> m_producerEntries;
        };

        std::ostream& operator<<( std::ostream& stream, ProducerTableEntryList ptel);
    }
}
#endif
