/*
 *  Copyright (c) 2004 on behalf of the EU EGEE Project:
 *  The European Organization for Nuclear Research (CERN),
 *  Istituto Nazionale di Fisica Nucleare (INFN), Italy
 *  Datamat Spa, Italy
 *  Centre National de la Recherche Scientifique (CNRS), France
 *  CS Systeme d'Information (CSSI), France
 *  Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
 *  Universiteit van Amsterdam (UvA), Netherlands
 *  University of Helsinki (UH.HIP), Finland
 *  University of Bergen (UiB), Norway
 *  Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom
 */
#ifndef RGMAWARNING_H
#define RGMAWARNING_H
#include <string>
namespace glite
{
    namespace rgma
    {
        /**
         * RGMAWarnings are used to warn about the quality of an answer to a query.
         * They are attached to ResultSets.
         */
        class RGMAWarning
        {
            public:
                /**
                 * Create a new RGMAWarning object.
                 *
                 * @param msg Details of warning.
                 */
                RGMAWarning(std::string msg = "");
                /**
                 * Gets the message for this warning.
                 *
                 * @return the messsage.
                 */
                std::string RGMAWarning::getMessage();

                virtual ~RGMAWarning();
            private:
                std::string m_msg;
        };
    }
}
#endif                                            // RMAWARNING_H
