
#ifndef RESOURCE_ENDPOINT_LIST_H
#define RESOURCE_ENDPOINT_LIST_H

#include "rgma/ResourceEndpoint.h"
#include <vector>

namespace glite
{
    namespace rgma
    {
        /**
         * A service or resource endpoint List.
         */
        class ResourceEndpointList
        {
            public:

                ResourceEndpointList();

                ~ResourceEndpointList();

                ResourceEndpointList(const ResourceEndpointList& endpointList);

                ResourceEndpointList& operator=(const ResourceEndpointList& endpointList);

                ResourceEndpoint getEndpoint(int index);

                void addEndpoint(ResourceEndpoint endpoint);

                void addEndpoint(int index, ResourceEndpoint endpoint);

                int size();
            private:

                std::vector<ResourceEndpoint> m_list;
        };

    }
}
#endif
