/* Copyright (c) 2003 EU DataGrid. */
/* For license conditions see http://www.eu-datagrid.org/license.html */

#ifndef GLITE_SSLUTILS_H
#define GLITE_SSLUTILS_H
#define OPENSSL_NO_KRB5
// OpenSSL types
typedef struct ssl_ctx_st SSL_CTX;
typedef struct x509_st X509;

namespace glite
{
    namespace rgma
    {

        /**
         * Static utility functions used by SSL classes, which don't conveniently fit
         * into any particular class.
         */

        class SSLUtils
        {
            private:
                //static const class APILogging& cat;

            public:

                /**
                 * Debuging method displays certificate subject and issuer to APILogging&
                 *
                 * @param source the certificate source - inserted into displayed message.  e.g.
                 * "server" or "client".
                 * @param certificate the certificate to display
                 */
                static void displayCertificate(const char* source, X509* certificate);

                /**
                 * Returns true if the certificate is a proxy certificate.
                 *
                 * @param certificate the certificate to check.
                 * @return true if the certificate is a proxy.
                 */
                static bool isAProxyCertificate(X509* certificate);

        };
    }
}
#endif                                            // EDG_INFO_SSLUTILS_H
