/*
 *  Copyright (c) 2004 on behalf of the EU EGEE Project:
 *  The European Organization for Nuclear Research (CERN),
 *  Istituto Nazionale di Fisica Nucleare (INFN), Italy
 *  Datamat Spa, Italy
 *  Centre National de la Recherche Scientifique (CNRS), France
 *  CS Systeme d'Information (CSSI), France
 *  Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
 *  Universiteit van Amsterdam (UvA), Netherlands
 *  University of Helsinki (UH.HIP), Finland
 *  University of Bergen (UiB), Norway
 *  Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom
 */
#ifndef RGMA_SOCKET_H
#define RGMA_SOCKET_H
#include "rgma/RGMAException.h"
#include "rgma/RemoteException.h"
#include <string>

namespace glite
{
    namespace rgma
    {
        /**
         * Socket wrapper
         */
        class Socket
        {
            private:
            public:
                virtual ~Socket(){}
                virtual void connect(std::string host, int port) throw(RGMAException, RemoteException) = 0;
                virtual void write(std::string request, std::string& resonse) throw(RGMAException, RemoteException) = 0;
                virtual void close()throw(RGMAException, RemoteException) = 0;
        };
    }
}
#endif
