#ifndef TABLEDEFINITIONLIST_H
#define TABLEDEFINITIONLIST_H

#include "rgma/ColumnDefinitionList.h"
#include <vector>

#include <string>

namespace glite
{
    namespace rgma
    {
        /**
         * Contains the column definitions for a table.
         */
        class TableDefinition
        {
            public:
                TableDefinition( std::string tableName, ColumnDefinitionList columns );
                ~TableDefinition(){}
                TableDefinition( const TableDefinition& def );

                TableDefinition& operator=(const TableDefinition& def  );
                /**
                 * @return Returns the table columns.
                 */
                ColumnDefinitionList getColumns();
                /**
                 * @return Returns the tableName.
                 */
                std::string getTableName();

            private:
                /**
                 * Table name.
                 */
                std::string m_tableName;

                /**
                 * Column definitions.
                 */
                ColumnDefinitionList m_columns;
        };
        std::ostream& operator<<( std::ostream& stream, TableDefinition td);
    }
}
#endif
