#ifndef TUPLELIST_H
#define TUPLELIST_H

#include "rgma/TupleStore.h"
#include <vector>
#include <string>

namespace glite
{
    namespace rgma
    {
        /**
         * A list of TupleStore objects.
         */
        class TupleStoreList
        {
            public:
                TupleStoreList();
                ~TupleStoreList(){}

                /**
                 * Retrieves the TupleStore with the specified index.
                 *
                 * @param index TupleStore of TupleStore to get (0 &lt;= index &lt; size)
                 *
                 * @return A TupleStore object.
                 */
                TupleStore getTupleStore(int index);
                /**
                 * adds an TupleStore to the list
                 *
                 * @param index TupleStore of TupleStore to put
                 *
                 *
                 */
                void add(TupleStore index);
                int size();
            private:
                std::vector<TupleStore> m_tupleStoreList;

        };
        std::ostream& operator<<( std::ostream& stream, TupleStoreList tsl);
    }
}
#endif
